# -*- coding:UTF-8 -*-
# @Time  : 2020/9/8 13:39
# @File  : spark_test.py
# @email : litao@igengmei.com
# @author : litao

# -*- coding:UTF-8 -*-
# @Time  : 2020/9/4 17:07
# @File  : search_meigou_ctr.py
# @email : litao@igengmei.com
# @author : litao

import hashlib
import json

import pymysql
import xlwt, datetime
import redis
# from pyhive import hive
from maintenance.func_send_email_with_file import send_file_email
from typing import Dict, List
from elasticsearch_7 import Elasticsearch
from elasticsearch_7.helpers import scan
import sys
import time
from pyspark import SparkConf
from pyspark.sql import SparkSession, DataFrame


# from pyspark.sql.functions import lit
# import pytispark.pytispark as pti
from elasticsearch import Elasticsearch

exists_es_dic = {}
es = Elasticsearch([
    {
        'host': '172.16.31.17',
        'port': 9200,
    }, {
        'host': '172.16.31.11',
        'port': 9200,
    }])

def con_sql(sql):
    # 从数据库的表里获取数据

    db = pymysql.connect(host='172.16.40.158', port=4000, user='st_user', passwd='aqpuBLYzEV7tML5RPsN1pntUzFy',
                         db='jerry_prod')
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    db.close()
    return result


startTime = time.time()
sparkConf = SparkConf()
sparkConf.set("spark.sql.crossJoin.enabled", True)
sparkConf.set("spark.debug.maxToStringFields", "100")
sparkConf.set("spark.tispark.plan.allow_index_double_read", False)
sparkConf.set("spark.tispark.plan.allow_index_read", True)
sparkConf.set("spark.hive.mapred.supports.subdirectories", True)
sparkConf.set("spark.hadoop.mapreduce.input.fileinputformat.input.dir.recursive", True)
sparkConf.set("spark.serializer", "org.apache.spark.serializer.KryoSerializer")
sparkConf.set("mapreduce.output.fileoutputformat.compress", False)
sparkConf.set("mapreduce.map.output.compress", False)
sparkConf.set("prod.gold.jdbcuri",
              "jdbc:mysql://172.16.30.136/doris_prod?user=doris&password=o5gbA27hXHHm&rewriteBatchedStatements=true")
sparkConf.set("prod.mimas.jdbcuri",
              "jdbc:mysql://172.16.30.138/mimas_prod?user=mimas&password=GJL3UJe1Ck9ggL6aKnZCq4cRvM&rewriteBatchedStatements=true")
sparkConf.set("prod.gaia.jdbcuri",
              "jdbc:mysql://172.16.30.143/zhengxing?user=work&password=BJQaT9VzDcuPBqkd&rewriteBatchedStatements=true")
sparkConf.set("prod.tidb.jdbcuri",
              "jdbc:mysql://172.16.40.158:4000/eagle?user=st_user&password=aqpuBLYzEV7tML5RPsN1pntUzFy&rewriteBatchedStatements=true")
sparkConf.set("prod.jerry.jdbcuri",
              "jdbc:mysql://172.16.40.158:4000/jerry_prod?user=st_user&password=aqpuBLYzEV7tML5RPsN1pntUzFy&rewriteBatchedStatements=true")
sparkConf.set("prod.tispark.pd.addresses", "172.16.40.158:2379")
sparkConf.set("prod.tispark.pd.addresses", "172.16.40.170:4000")
sparkConf.set("prod.tidb.database", "jerry_prod")
sparkConf.setAppName("test")

spark = (SparkSession.builder.config(conf=sparkConf).config("spark.sql.extensions", "org.apache.spark.sql.TiExtensions")
         .config("spark.tispark.pd.addresses", "172.16.40.170:2379").enableHiveSupport().getOrCreate())

spark.sql("ADD JAR hdfs:///user/hive/share/lib/udf/brickhouse-0.7.1-SNAPSHOT.jar")
spark.sql("ADD JAR hdfs:///user/hive/share/lib/udf/hive-udf-1.0-SNAPSHOT.jar")
spark.sql("CREATE TEMPORARY FUNCTION json_map AS 'brickhouse.udf.json.JsonMapUDF'")
spark.sql("CREATE TEMPORARY FUNCTION is_json AS 'com.gmei.hive.common.udf.UDFJsonFormatCheck'")
spark.sql("CREATE TEMPORARY FUNCTION arrayMerge AS 'com.gmei.hive.common.udf.UDFArryMerge'")


# print(huidu_device_id_sql)
# huidu_device_id_df = spark.sql(huidu_device_id_sql)
# huidu_device_id_df.createOrReplaceTempView("dev_view")
sql_search_ctr = r"""
select count(1) from (
 SELECT  partition_date,
                    
                    cl_id,
                    v.recommend_type,
                    count(card_id) as session_pv0,
                    count(distinct app_session_id) as session_pv
            FROM
            (
               SELECT partition_date,
                      cl_id,
                      case when card_content_type in ('qa','answer') then 'qa'
                           when card_content_type in ('special_pool') then 'special' else card_content_type end as card_content_type,
                      CASE when transaction_type in ('fmctr','samecity_fmctr') then array('fmctr','合计')
                           when transaction_type in ('high_quality_fmctr') then array('high_quality_fmctr','合计')
                           WHEN (transaction_type like '%ctr' and transaction_type not in ('high_quality_ctr','high_quality_fmctr','fmctr','samecity_fmctr') ) THEN array('ctr预估','合计')
                           when transaction_type in ('high_quality_ctr') then array('high_quality_ctr','合计')
                           WHEN transaction_type like '%cvr' THEN array('cvr预估','合计')
                           WHEN transaction_type in ('-1','smr') THEN array('smr','合计')
                           when transaction_type in ('pgc','hotspot') then array('热点卡片')
                           when transaction_type in ('newdata') then array('保量卡片')
                           when transaction_type in ('hotspot_feed') then array('hotspot_feed','合计')
                           when transaction_type in ('aistragegy') then array('新用户AI帖优先','合计')
                           when transaction_type in ('excestragegy') then array('新用户精华帖优先','合计')
                           when transaction_type in ('FIXEDSTRATEGY') then array('新氧新用户策略一','合计')
                           when transaction_type in ('FIXEDSTRATEGY_VIDEO') then array('新氧新用户策略二','合计')
                           when transaction_type like 'deeplink%' then array('deeplink策略','合计')
                           end AS recommend_type,
                      card_id,
                      app_session_id
               from online.ml_community_precise_exposure_detail
               WHERE partition_date={partition_day}
               AND action in ('page_precise_exposure','home_choiceness_card_exposure') --7745版本action改为page_precise_exposure
               AND is_exposure = '1'  ----精准曝光
               AND page_name ='home'
               AND tab_name = '精选'
               AND (transaction_type in ('-1','smr','hotspot','pgc','newdata','hotspot_feed','aistragegy','excestragegy','FIXEDSTRATEGY','FIXEDSTRATEGY_VIDEO')
                    or transaction_type like '%ctr' or transaction_type like '%cvr' or transaction_type like 'deeplink%')
               AND card_content_type in ('qa','diary','user_post','answer','special_pool')
               group by partition_date,
                      case when card_content_type in ('qa','answer') then 'qa'
                           when card_content_type in ('special_pool') then 'special' else card_content_type end,
                      cl_id,
                      CASE when transaction_type in ('fmctr','samecity_fmctr') then array('fmctr','合计')
                           when transaction_type in ('high_quality_fmctr') then array('high_quality_fmctr','合计')
                           WHEN (transaction_type like '%ctr' and transaction_type not in ('high_quality_ctr','high_quality_fmctr','fmctr','samecity_fmctr')) THEN array('ctr预估','合计')
                           when transaction_type in ('high_quality_ctr') then array('high_quality_ctr','合计')
                           WHEN transaction_type like '%cvr' THEN array('cvr预估','合计')
                           WHEN transaction_type in ('-1','smr') THEN array('smr','合计')
                           when transaction_type in ('pgc','hotspot') then array('热点卡片')
                           when transaction_type in ('newdata') then array('保量卡片')
                           when transaction_type in ('hotspot_feed') then array('hotspot_feed','合计')
                           when transaction_type in ('aistragegy') then array('新用户AI帖优先','合计')
                           when transaction_type in ('excestragegy') then array('新用户精华帖优先','合计')
                           when transaction_type in ('FIXEDSTRATEGY') then array('新氧新用户策略一','合计')
                           when transaction_type in ('FIXEDSTRATEGY_VIDEO') then array('新氧新用户策略二','合计')
                           when transaction_type like 'deeplink%' then array('deeplink策略','合计') end,
                      card_id,
                      app_session_id
            )a
            LATERAL VIEW explode (a.recommend_type) v as recommend_type
            group by partition_date,cl_id,v.recommend_type having session_pv0 >= 4)
""".format(partition_day='20201105',end_date='20201025')

print(sql_search_ctr)
search_ctr_df = spark.sql(sql_search_ctr)
# spam_pv_df.createOrReplaceTempView("dev_view")
search_ctr_df.show(1)
sql_res = search_ctr_df.collect()

print("-------------------------------")
for res in sql_res:
    print(res)
    # print(res.query,res.search_pv)
    # results = es.search(
    #     index='gm-dbmw-diary-read',
    #     doc_type='diary',
    #     timeout='10s',
    #     body=body
    # )

